/*
 * Copyright
 *   2007 axYus - www.axyus.com
 *   2010 C. ARIOUAT - Assia.ARIOUAt@axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.dgfip.xemelios.controls.facturessansengagementtiers;

import java.util.Hashtable;
import java.util.Stack;
import java.util.Vector;

import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;

import fr.gouv.finances.cp.xemelios.controls.AbstractUnitControl;
import fr.gouv.finances.cp.xemelios.controls.Anomalie;
import fr.gouv.finances.cp.xemelios.controls.IdGenerator;
import fr.gouv.finances.cp.xemelios.controls.Node;

/**
 * Si ID_AMG commence par CRG alors T_FONC est obligatoire
 *
 * @author Assia ARIOUAT
 */

public class M213 extends AbstractUnitControl {
    public static final String CTRL_ID = "CTL-M213" ;
    public static final transient String RESET_COUNTER_PATH = "FEN0052A/FACTURE/";
    public static final transient String NUM_FACT_PATH = "FEN0052A/FACTURE/ENTETE/NUM_FACT/";
    public static final transient String POSTE_ID = "FEN0052A/FACTURE/LIGNE_POSTE/POSTE/";
    public static final transient String POSTE_PATH = "FEN0052A/FACTURE/LIGNE_POSTE/";
    public static final transient String POSTE_ID_AMG= "FEN0052A/FACTURE/LIGNE_POSTE/ID_AMG/";
    public static final transient String POSTE_T_FONC= "FEN0052A/FACTURE/LIGNE_POSTE/T_FONC/";
    public static final transient String RETURN_ANOMALIES_PATH = RESET_COUNTER_PATH;

    private static final Logger logger = Logger.getLogger(M213.class);

    // pour stocker tous les paramètres d'execution des controles
    private Hashtable<String,Object> hParams;

    // pour stocker l'identifiant de l'invoice, on en a besoin pour générer l'anomalie
    private String numfact = "";
	private String ID_Facture_Unique = "";
    private String poste_Id = "";
    private String poste_Nod = "";
    private String id_amg = "";
    private String t_fonc = "";
    private String numLigneTexte = "";
    
    //Varriables du message d'erreur
    
	private static final String MSG_ENTETE_IDFACTURE = "#ENTETE_IDFACTURE#";
	private static final String MSG_POSTE_ID = "#POSTE_ID#";
	
    
    // pour récupérer le texte des balises
    private Stack<StringBuffer> chars = new Stack<StringBuffer>();

    // pour stocker les anomalies que l'on génère
    Vector<Anomalie> anomalies = null;

    public void endDocument() throws SAXException { }

    public void startElement(String uri, String localName, String qName, Attributes atts, String xpath) throws SAXException {
        if(xpath.equals(RESET_COUNTER_PATH)) {           
            anomalies = new Vector<Anomalie>();
            numfact = "";   
            ID_Facture_Unique = atts.getValue("ano:unique-id");
        } else if(xpath.equals(POSTE_PATH)) {
        	poste_Id = "";
        	t_fonc=id_amg="";
        	poste_Nod= atts.getValue("ano:node-id");
        	}
        else if(atts.getValue("txt2xml:LineTxt")!=null){
        		numLigneTexte = atts.getValue("txt2xml:LineTxt");
        			} else {
        				numLigneTexte = "";
        			}
        
        chars.push(new StringBuffer());
    }

    public Vector<Anomalie> endElement(String uri, String localName, String qName, String xpath) throws SAXException {
        if(xpath.equals(NUM_FACT_PATH)) {
        	numfact = chars.peek().toString();
        } else if(xpath.equals(POSTE_ID)) {   
        	poste_Id = chars.peek().toString();
        } else if(xpath.equals(POSTE_ID_AMG)) {   
        	id_amg = chars.peek().toString();
        } else if(xpath.equals(POSTE_T_FONC)) {   
        	t_fonc = chars.peek().toString();
        } else if(xpath.equals(POSTE_PATH)) {   
        
        	if ( id_amg.startsWith("CRG")&&(t_fonc.length()==0)) {
        		String msg = (numLigneTexte.length()>0?"Ligne n°"+numLigneTexte+" : ":"");
    			msg += getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
    			msg = msg.replaceAll(MSG_ENTETE_IDFACTURE, numfact);
    			msg = msg.replaceAll(MSG_POSTE_ID, poste_Id);
    			
    			String path = "@ano:unique-id='" + ID_Facture_Unique + "'";
    			String anoId = IdGenerator.nextId();
    			String libelleLien = "Entete "+numfact;
    			Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
    			xslParams.put("anoId", anoId);
    			xslParams.put("presentation", "src");
    			Anomalie ano = new Anomalie(anoId,
                                        getDocumentModel().getControlById(CTRL_ID).getId(),
                                        getDocumentModel().getControlById(CTRL_ID).getLibelle(),
                                        getDocumentModel().getDocumentId(),
                                        "FEN0052A",
                                        "FACTURE", // élément importable
                                        numfact, // id élément importable
                                        localName,
                                        libelleLien,
                                        msg,
                                        getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
                                        getDocumentModel().getControlById(CTRL_ID).getSeverity(),
                                        path,
                                        xslParams);
                    ano.addNode(new Node(poste_Nod));
                    anomalies.add(ano);
        	}
            chars.pop();
            return null;
        } else if(xpath.equals(RETURN_ANOMALIES_PATH)) {
        	chars.pop();
            return anomalies;
        }
        chars.pop();
        return null;
    }

    public void characters(char[] ch, int start, int length, String xpath) throws SAXException {
        // on met les caractères lus dans la pile
        chars.peek().append(ch, start, length);
    }

    public void ignorableWhitespace(char[] ch, int start, int length, String xpath) throws SAXException { }

    public void processingInstruction(String target, String data, String xpath) throws SAXException { }

    public void skippedEntity(String name, String xpath) throws SAXException { }

    public void setParameters(Hashtable<String, Object> params) {
        this.hParams=params;
    }

    public void setDocumentLocator(Locator locator) { }

    public void startDocument() throws SAXException { }

    public void startPrefixMapping(String prefix, String uri, String xpath) throws SAXException { }

    public void endPrefixMapping(String prefix, String xpath) throws SAXException { }
}
